/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2011 Google Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY GOOGLE, INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#pragma once

namespace WebCore {

enum EventTargetInterface {
#if ENABLE(APPLE_PAY)
    ApplePaySessionEventTargetInterfaceType = 1,
#endif
#if ENABLE(DOM_AUDIO_SESSION)
    DOMAudioSessionEventTargetInterfaceType = 2,
#endif
#if ENABLE(ENCRYPTED_MEDIA)
    MediaKeySessionEventTargetInterfaceType = 3,
#endif
#if ENABLE(LEGACY_ENCRYPTED_MEDIA)
    WebKitMediaKeySessionEventTargetInterfaceType = 4,
#endif
#if ENABLE(MEDIA_RECORDER)
    MediaRecorderEventTargetInterfaceType = 5,
#endif
#if ENABLE(MEDIA_SESSION_COORDINATOR)
    MediaSessionCoordinatorEventTargetInterfaceType = 6,
#endif
#if ENABLE(MEDIA_SOURCE)
    MediaSourceEventTargetInterfaceType = 7,
    SourceBufferEventTargetInterfaceType = 8,
    SourceBufferListEventTargetInterfaceType = 9,
#endif
#if ENABLE(MEDIA_STREAM)
    MediaDevicesEventTargetInterfaceType = 10,
    MediaStreamEventTargetInterfaceType = 11,
    MediaStreamTrackEventTargetInterfaceType = 12,
#endif
#if ENABLE(NOTIFICATIONS)
    NotificationEventTargetInterfaceType = 13,
#endif
#if ENABLE(OFFSCREEN_CANVAS)
    OffscreenCanvasEventTargetInterfaceType = 14,
#endif
#if ENABLE(PAYMENT_REQUEST)
    PaymentRequestEventTargetInterfaceType = 15,
    PaymentResponseEventTargetInterfaceType = 16,
#endif
#if ENABLE(PICTURE_IN_PICTURE_API)
    PictureInPictureWindowEventTargetInterfaceType = 17,
#endif
#if ENABLE(SERVICE_WORKER)
    ServiceWorkerEventTargetInterfaceType = 18,
    ServiceWorkerContainerEventTargetInterfaceType = 19,
    ServiceWorkerGlobalScopeEventTargetInterfaceType = 20,
    ServiceWorkerRegistrationEventTargetInterfaceType = 21,
#endif
#if ENABLE(SPEECH_SYNTHESIS)
    SpeechSynthesisEventTargetInterfaceType = 22,
    SpeechSynthesisUtteranceEventTargetInterfaceType = 23,
#endif
#if ENABLE(VIDEO)
    AudioTrackListEventTargetInterfaceType = 24,
    MediaControllerEventTargetInterfaceType = 25,
    TextTrackEventTargetInterfaceType = 26,
    TextTrackCueEventTargetInterfaceType = 27,
    TextTrackCueGenericEventTargetInterfaceType = 28,
    TextTrackListEventTargetInterfaceType = 29,
    VideoTrackListEventTargetInterfaceType = 30,
#endif
#if ENABLE(WEBXR)
    WebXRLayerEventTargetInterfaceType = 31,
    WebXRSessionEventTargetInterfaceType = 32,
    WebXRSpaceEventTargetInterfaceType = 33,
    WebXRSystemEventTargetInterfaceType = 34,
#endif
#if ENABLE(WEB_AUDIO)
    AudioNodeEventTargetInterfaceType = 35,
    BaseAudioContextEventTargetInterfaceType = 36,
#endif
#if ENABLE(WEB_CODECS)
    WebCodecsVideoDecoderEventTargetInterfaceType = 37,
    WebCodecsVideoEncoderEventTargetInterfaceType = 38,
#endif
#if ENABLE(WEB_RTC)
    RTCDTMFSenderEventTargetInterfaceType = 39,
    RTCDataChannelEventTargetInterfaceType = 40,
    RTCDtlsTransportEventTargetInterfaceType = 41,
    RTCIceTransportEventTargetInterfaceType = 42,
    RTCPeerConnectionEventTargetInterfaceType = 43,
    RTCRtpSFrameTransformEventTargetInterfaceType = 44,
    RTCRtpScriptTransformEventTargetInterfaceType = 45,
    RTCSctpTransportEventTargetInterfaceType = 46,
#endif
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
    RemotePlaybackEventTargetInterfaceType = 47,
#endif
    EventTargetInterfaceType = 48,
    AbortSignalEventTargetInterfaceType = 49,
    BroadcastChannelEventTargetInterfaceType = 50,
    ClipboardEventTargetInterfaceType = 51,
    DOMApplicationCacheEventTargetInterfaceType = 52,
    DOMWindowEventTargetInterfaceType = 53,
    DedicatedWorkerGlobalScopeEventTargetInterfaceType = 54,
    EventSourceEventTargetInterfaceType = 55,
    FileReaderEventTargetInterfaceType = 56,
    FontFaceSetEventTargetInterfaceType = 57,
    GPUDeviceEventTargetInterfaceType = 58,
    IDBDatabaseEventTargetInterfaceType = 59,
    IDBOpenDBRequestEventTargetInterfaceType = 60,
    IDBRequestEventTargetInterfaceType = 61,
    IDBTransactionEventTargetInterfaceType = 62,
    MediaQueryListEventTargetInterfaceType = 63,
    MessagePortEventTargetInterfaceType = 64,
    NodeEventTargetInterfaceType = 65,
    PerformanceEventTargetInterfaceType = 66,
    PermissionStatusEventTargetInterfaceType = 67,
    ScreenOrientationEventTargetInterfaceType = 68,
    SharedWorkerEventTargetInterfaceType = 69,
    SharedWorkerGlobalScopeEventTargetInterfaceType = 70,
    SpeechRecognitionEventTargetInterfaceType = 71,
    VisualViewportEventTargetInterfaceType = 72,
    WakeLockSentinelEventTargetInterfaceType = 73,
    WebAnimationEventTargetInterfaceType = 74,
    WebSocketEventTargetInterfaceType = 75,
    WorkerEventTargetInterfaceType = 76,
    WorkletGlobalScopeEventTargetInterfaceType = 77,
    XMLHttpRequestEventTargetInterfaceType = 78,
    XMLHttpRequestUploadEventTargetInterfaceType = 79,
};

} // namespace WebCore
