/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(MEDIA_RECORDER)

#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMWrapper.h"
#include "JSEventTarget.h"
#include "MediaRecorder.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSMediaRecorder : public JSEventTarget {
public:
    using Base = JSEventTarget;
    using DOMWrapped = MediaRecorder;
    static JSMediaRecorder* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<MediaRecorder>&& impl)
    {
        JSMediaRecorder* ptr = new (NotNull, JSC::allocateCell<JSMediaRecorder>(globalObject->vm())) JSMediaRecorder(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static MediaRecorder* toWrapped(JSC::VM&, JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info(), JSC::NonArray);
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    template<typename, JSC::SubspaceAccess mode> static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        if constexpr (mode == JSC::SubspaceAccess::Concurrently)
            return nullptr;
        return subspaceForImpl(vm);
    }
    static JSC::GCClient::IsoSubspace* subspaceForImpl(JSC::VM& vm);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    MediaRecorder& wrapped() const
    {
        return static_cast<MediaRecorder&>(Base::wrapped());
    }
protected:
    JSMediaRecorder(JSC::Structure*, JSDOMGlobalObject&, Ref<MediaRecorder>&&);

    void finishCreation(JSC::VM&);
};

class JSMediaRecorderOwner final : public JSC::WeakHandleOwner {
public:
    bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::AbstractSlotVisitor&, const char**) final;
    void finalize(JSC::Handle<JSC::Unknown>, void* context) final;
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, MediaRecorder*)
{
    static NeverDestroyed<JSMediaRecorderOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(MediaRecorder* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, MediaRecorder&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, MediaRecorder* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<MediaRecorder>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<MediaRecorder>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<MediaRecorder> {
    using WrapperClass = JSMediaRecorder;
    using ToWrappedReturnType = MediaRecorder*;
};
String convertEnumerationToString(MediaRecorder::RecordingState);
template<> JSC::JSString* convertEnumerationToJS(JSC::JSGlobalObject&, MediaRecorder::RecordingState);

template<> std::optional<MediaRecorder::RecordingState> parseEnumerationFromString<MediaRecorder::RecordingState>(const String&);
template<> std::optional<MediaRecorder::RecordingState> parseEnumeration<MediaRecorder::RecordingState>(JSC::JSGlobalObject&, JSC::JSValue);
template<> const char* expectedEnumerationValues<MediaRecorder::RecordingState>();

template<> MediaRecorder::Options convertDictionary<MediaRecorder::Options>(JSC::JSGlobalObject&, JSC::JSValue);


} // namespace WebCore

#endif // ENABLE(MEDIA_RECORDER)
