/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(NOTIFICATIONS)

#include "JSNotificationDirection.h"

#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSString.h>
#include <wtf/NeverDestroyed.h>
#include <wtf/SortedArrayMap.h>


namespace WebCore {
using namespace JSC;

String convertEnumerationToString(NotificationDirection enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("auto"),
        MAKE_STATIC_STRING_IMPL("ltr"),
        MAKE_STATIC_STRING_IMPL("rtl"),
    };
    static_assert(static_cast<size_t>(NotificationDirection::Auto) == 0, "NotificationDirection::Auto is not 0 as expected");
    static_assert(static_cast<size_t>(NotificationDirection::Ltr) == 1, "NotificationDirection::Ltr is not 1 as expected");
    static_assert(static_cast<size_t>(NotificationDirection::Rtl) == 2, "NotificationDirection::Rtl is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < std::size(values));
    return values[static_cast<size_t>(enumerationValue)];
}

template<> JSString* convertEnumerationToJS(JSGlobalObject& lexicalGlobalObject, NotificationDirection enumerationValue)
{
    return jsStringWithCache(lexicalGlobalObject.vm(), convertEnumerationToString(enumerationValue));
}

template<> std::optional<NotificationDirection> parseEnumerationFromString<NotificationDirection>(const String& stringValue)
{
    static constexpr std::pair<ComparableASCIILiteral, NotificationDirection> mappings[] = {
        { "auto", NotificationDirection::Auto },
        { "ltr", NotificationDirection::Ltr },
        { "rtl", NotificationDirection::Rtl },
    };
    static constexpr SortedArrayMap enumerationMapping { mappings };
    if (auto* enumerationValue = enumerationMapping.tryGet(stringValue); LIKELY(enumerationValue))
        return *enumerationValue;
    return std::nullopt;
}

template<> std::optional<NotificationDirection> parseEnumeration<NotificationDirection>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    return parseEnumerationFromString<NotificationDirection>(value.toWTFString(&lexicalGlobalObject));
}

template<> const char* expectedEnumerationValues<NotificationDirection>()
{
    return "\"auto\", \"ltr\", \"rtl\"";
}

} // namespace WebCore

#endif // ENABLE(NOTIFICATIONS)
