/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(SERVICE_WORKER)

#include "JSDOMConvertEnumeration.h"
#include "JSDOMWrapper.h"
#include "JSEventTarget.h"
#include "ServiceWorker.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class WEBCORE_EXPORT JSServiceWorker : public JSEventTarget {
public:
    using Base = JSEventTarget;
    using DOMWrapped = ServiceWorker;
    static JSServiceWorker* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<ServiceWorker>&& impl)
    {
        JSServiceWorker* ptr = new (NotNull, JSC::allocateCell<JSServiceWorker>(globalObject->vm())) JSServiceWorker(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static ServiceWorker* toWrapped(JSC::VM&, JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info(), JSC::NonArray);
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    template<typename, JSC::SubspaceAccess mode> static JSC::GCClient::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        if constexpr (mode == JSC::SubspaceAccess::Concurrently)
            return nullptr;
        return subspaceForImpl(vm);
    }
    static JSC::GCClient::IsoSubspace* subspaceForImpl(JSC::VM& vm);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    ServiceWorker& wrapped() const
    {
        return static_cast<ServiceWorker&>(Base::wrapped());
    }
protected:
    JSServiceWorker(JSC::Structure*, JSDOMGlobalObject&, Ref<ServiceWorker>&&);

    void finishCreation(JSC::VM&);
};

class WEBCORE_EXPORT JSServiceWorkerOwner final : public JSC::WeakHandleOwner {
public:
    bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::AbstractSlotVisitor&, const char**) final;
    void finalize(JSC::Handle<JSC::Unknown>, void* context) final;
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, ServiceWorker*)
{
    static NeverDestroyed<JSServiceWorkerOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(ServiceWorker* wrappableObject)
{
    return wrappableObject;
}

WEBCORE_EXPORT JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, ServiceWorker&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, ServiceWorker* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<ServiceWorker>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<ServiceWorker>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<ServiceWorker> {
    using WrapperClass = JSServiceWorker;
    using ToWrappedReturnType = ServiceWorker*;
};
String convertEnumerationToString(ServiceWorker::State);
template<> JSC::JSString* convertEnumerationToJS(JSC::JSGlobalObject&, ServiceWorker::State);

template<> std::optional<ServiceWorker::State> parseEnumerationFromString<ServiceWorker::State>(const String&);
template<> std::optional<ServiceWorker::State> parseEnumeration<ServiceWorker::State>(JSC::JSGlobalObject&, JSC::JSValue);
template<> const char* expectedEnumerationValues<ServiceWorker::State>();


} // namespace WebCore

#endif // ENABLE(SERVICE_WORKER)
